using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Components.Containers;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Bson.Serialization;
using MongoDB.Bson.Serialization.Attributes;
using MongoDB.Driver;
using MudBlazor;
using System.Text.RegularExpressions;
using SortDirection = MudBlazor.SortDirection;

namespace Insight.Web.Pages.Monitoring.Maintenance.Volumes;

[Route(Navigation.Monitoring.Maintenance.Volumes.Index)]
public partial class Index
{
    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;

    private TableContainer<ViewModel>? Container { get; set; }
    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private string? Search { get; set; }

    protected override void OnInitialized()
    {
        Title = $"Monitoring » Maintenance » Volumes｜Insight";
        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Monitoring", href: Navigation.Monitoring.Index));
        Breadcrumbs.Add(new BreadcrumbItem("Maintenance", href: Navigation.Monitoring.Maintenance.Index));
        Breadcrumbs.Add(new BreadcrumbItem("Volumes", href: "#", true));
    }

    private async Task<TableData<ViewModel>> LoadDataAsync(TableState state)
    {
        try
        {
            var filter = Builders<HostVolumeEntity>.Filter.Ne(p => p.FreeSpace, null);
            var search = Builders<BsonDocument>.Filter.Empty;

            if (string.IsNullOrWhiteSpace(Search) is false)
            {
                var regex = new BsonRegularExpression(new Regex(Search, RegexOptions.IgnoreCase));
                search &= Builders<BsonDocument>.Filter.Regex("customer.name", regex) |
                    Builders<BsonDocument>.Filter.Regex("host.name", regex) |
                    Builders<BsonDocument>.Filter.Regex("name", regex);
            }

            var query = Database.HostVolume()
                .Aggregate()
                .Match(filter)
                .Project<BsonDocument>(new BsonDocument
                {
                    { "_id", 1 },
                    { "name", 1 },
                    { "size", 1 },
                    { "freespace", 1 },
                    { "drive", 1 },
                    { "_host", 1 },
                    { "percent_free", new BsonDocument("$multiply", new BsonArray
                        {
                            new BsonDocument("$divide",
                            new BsonArray
                                {
                                    "$freespace",
                                    "$size"
                                }),
                            100
                        })
                    }
                })
                .Match(new BsonDocument("percent_free", new BsonDocument("$lt", 5)))
                .Lookup("host", "_host", "_id", "hosts")
                .Match(new BsonDocument("hosts", new BsonDocument("$size", 1)))
                .Lookup("customer", "hosts._customer", "_id", "customers")
                .Project<BsonDocument>(new BsonDocument
                {
                    { "_id", 1 },
                    { "name", 1 },
                    { "size", 1 },
                    { "freespace", 1 },
                    { "percent_free", 1 },
                    { "drive", 1 },
                    { "customer", new BsonDocument("$first", "$customers") },
                    { "host", new BsonDocument("$first", "$hosts") }
                })
                .Match(search)
                .Sort(state.SortDirection switch
                {
                    SortDirection.Ascending => state.SortLabel switch
                    {
                        "Host" => Builders<BsonDocument>.Sort.Ascending("host"),
                        "Customer" => Builders<BsonDocument>.Sort.Ascending("customer"),
                        "Name" => Builders<BsonDocument>.Sort.Ascending("name"),
                        "Free" => Builders<BsonDocument>.Sort.Ascending("percent_free"),
                        _ => null
                    },
                    SortDirection.Descending => state.SortLabel switch
                    {
                        "Host" => Builders<BsonDocument>.Sort.Descending("host"),
                        "Customer" => Builders<BsonDocument>.Sort.Descending("customer"),
                        "Name" => Builders<BsonDocument>.Sort.Descending("name"),
                        "Free" => Builders<BsonDocument>.Sort.Descending("percent_free"),
                        _ => null
                    },
                    _ => Builders<BsonDocument>.Sort.Ascending("freespace")
                });

            var countResult = await query.Count().FirstOrDefaultAsync(default);
            var itemResult = await query.Skip(state.Page * state.PageSize).Limit(state.PageSize).ToListAsync(default);

            return new TableData<ViewModel>()
            {
                TotalItems = countResult is null ? 0 : (int)countResult.Count,
                Items = itemResult.Select(x => BsonSerializer.Deserialize<ViewModel>(x))
            };
        }
        catch (Exception)
        {
            Notification.Error(Snackbar);
            return new TableData<ViewModel>();
        }
    }

    [BsonIgnoreExtraElements]
    public class ViewModel
    {
        [BsonId]
        public ObjectId? Id { get; set; }

        [BsonElement("drive")]
        public ObjectId? Drive { get; set; }

        [BsonElement("name")]
        public string? Name { get; set; }

        [BsonElement("size")]
        public long? Size { get; set; }

        [BsonElement("freespace")]
        public long? FreeSpace { get; set; }

        [BsonElement("percent_free")]
        public double? PercentFree { get; set; }

        [BsonElement("host")]
        public HostEntity? Host { get; set; }

        [BsonElement("customer")]
        public CustomerEntity? Customer { get; set; }
    }
}